 TITLE   "RESETATOR, Milan Cizek 2003, v1.5"

 LIST    P=16F84,R=HEX
 INCLUDE "P16F84.inc"


#DEFINE		LED	PORTB,0
#DEFINE		RELE	PORTB,1

		CBLOCK	0x20		; blok definice promnnch
COUNTER					; citac prubehu
TEMP_W					; puvodni W
TEMP_S					; puvodni STATUS
DELAY1,DELAY2,DELAY3,DELAY4,DELAY5	; casove smycky
		ENDC


 __CONFIG	_XT_OSC & _PWRTE_OFF & _WDT_OFF & _CP_OFF


		org	0
		goto	START		; skok na zacatek programu

		org	4		; obslouzeni preruseni
		movwf	TEMP_W		; zaloha reg. W
  		swapf	STATUS,W	; registr STATUS -> W
  		movwf	TEMP_S		; zaloha reg. STATUS

					; vlastni kod preruseni

		swapf	TEMP_S,W	; pvodn STATUS -> W
		movwf	STATUS		; navraceni STATUS
  		swapf	TEMP_W,f
  		swapf	TEMP_W,W	; navrat puvodnho W 
		retfie



START		bcf	INTCON,GIE	; zakaz vsech preruseni

		bsf	STATUS,RP0	; prepneme do banky 1
		movlw	B'11111100'	; zapis do reg. W
		movwf	TRISB		; W -> TRISB
		bcf	STATUS,RP0	; prepneme do banky 0


		movlw	0x05		; zapis do reg. W
		movwf	COUNTER		; W -> COUNTER

		bsf	LED		; rozsvitit LED
		call	DELAY_05sec	; zpozdeni 0.5s
		bcf	LED		; zhasnout LED
		call	DELAY_05sec	; zpozdeni 0.5s
		decfsz	COUNTER,f	; W-1 a zpet do W
		goto	$-5


LOOP		bcf	RELE		; rozepnout RELE
		bsf	LED		; rozsvitit LED

		call	DELAY_24hr	; zpozdeni 24 hodin

		bcf	LED		; zhasnout LED
		call	DELAY_05sec	; zpozdeni 0.5s
		bsf	RELE		; sepnout RELE


		movlw	0x0a		; zapis do reg. W
		movwf	COUNTER		; W -> COUNTER

		bsf	LED		; rozsvitit LED
		call	DELAY_05sec	; zpozdeni 0.5s
		bcf	LED		; zhasnout LED
		call	DELAY_05sec	; zpozdeni 0.5s
		decfsz	COUNTER,f	; W-1 a zpet do W
		goto	$-5

		goto	LOOP



; Clock frequency = 3.2768 MHz
; Actual delay = 0.5 seconds = 409600 cycles, Error = 0 %

DELAY_05sec	movlw	0x91
		movwf	DELAY1
		movlw	0xe5
		movwf	DELAY2
		movlw	0x01
		movwf	DELAY3

		decfsz	DELAY1,f
		goto	$+2
		decfsz	DELAY2,f
		goto	$+2
		decfsz	DELAY3,f
		goto	$-5

		; 4 cycles (including call)
		return


; Actual delay = 10368000 seconds = 8493465600000 cycles, Error = 0 %

DELAY_48hr	movlw	0x8a
		movwf	DELAY1
		movlw	0x2f
		movwf	DELAY2
		movlw	0xbb
		movwf	DELAY3
		movlw	0xc7
		movwf	DELAY4
		movlw	0xb4
		movwf	DELAY5

		decfsz	DELAY1,f
		goto	$+2
		decfsz	DELAY2,f
		goto	$+2
		decfsz	DELAY3,f
		goto	$+2
		decfsz	DELAY4,f
		goto	$+2
		decfsz	DELAY5,f
		goto	$-9

		goto	$+1		; 5 cycles
		goto	$+1
		nop

		; 4 cycles (including call)
		return


; Actual delay = 86400 seconds = 70778880000 cycles, Error = 0 %

DELAY_24hr	movlw	0x73
		movwf	DELAY1
		movlw	0xD2
		movwf	DELAY2
		movlw	0x86
		movwf	DELAY3
		movlw	0x80
		movwf	DELAY4
		movlw	0x02
		movwf	DELAY5

		decfsz	DELAY1,f
		goto	$+2
		decfsz	DELAY2,f
		goto	$+2
		decfsz	DELAY3,f
		goto	$+2
		decfsz	DELAY4,f
		goto	$+2
		decfsz	DELAY5,f
		goto	$-9

		goto	$+1	;2 cycles

		; 4 cycles (including call)
		return


		END